$ZAPT_Temp::Mutation::Name = "Versus";
$ZAPT_Temp::Mutation::uiName = "Versus";
$ZAPT_Temp::Mutation::Bots = false;
$ZAPT_Temp::Mutation::HumanRespawn = false;
$ZAPT_Temp::Mutation::Saferooms = true;

function Mutation_Versus_Assemble(%mini)
{
	if(%mini.numMembers < 2)
	{
		%mini.messageAll('', "<color:ffaaaa>You cannot play Versus without at least 2 players.");
		%mini.ZAPT_GameMode = 0;
		return false;
	}
	else if(!%mini.zombieAssembledOnce)
	{
		if(!%mini.ZAPT_PlayerZombies)
		{
			%mini.ZAPT_PlayerZombies = true;
			%mini.messageAll('', "\c3Allow Player Zombies<color:ffaaaa> enabled to accomodate Versus mode.");
		}
		
		%numInfected = mFloor(%mini.numMembers / 2);
		
		for(%maxRuns = 250; %numInfected > 0 && %maxRuns > 0; %maxRuns--)
		{
			for(%a = 0; %a < %mini.numMembers; %a++)
			{
				%infClient = %mini.member[%a];
				
				if(!%infClient.isZombie)
				{
					%odds = %mini.numMembers + %infClient.zombieVersusInRow - %numInfected - 1;
					
					if(%odds <= 0 || !getRandom(0, %odds))
					{
						%numInfected--;
						%infClient.isZombie = true;
						%infClient.zombieVersusInRow++;
						
						messageClient(%infClient, '', "<color:ffaaaa>You were randomly selected to play infected this round.");
						
						%buddyOfBuddy = false;
						
						for(%b = 0; %b < %infClient.zombieHudCells && %numInfected > 0; %b++)
						{
							%buddy = %infClient.zombieBuddy[%b];
							
							if(isObject(%buddy) && %buddy.getID() != %infClient.getID())
							{
								for(%c = 0; %c < %buddy.zombieHudCells; %c++)
								{
									%theirBuddy = %buddy.zombieBuddy[%c];
									
									if(isObject(%theirBuddy) && %theirBuddy.getID() == %infClient.getID())
									{
										%numInfected--;
										%buddy.isZombie = true;
										%buddy.zombieVersusInRow++;
										%infClient.zombieVersusInRow++;
										
										messageClient(%infClient, '', "<color:ffaaaa>Your mutual buddy <color:ffffaa>" @ %buddy.name @ "<color:ffaaaa> was dragged into the Undead Army because of you.");
										messageClient(%buddy, '', "<color:ffaaaa>You were selected to play infected this round, because your mutual buddy (<color:ffffaa>" @ %infClient.name @ "<color:ffaaaa>) was.");
										
										break;
									}
								}
							}
						}
					}
				}
				
				if(%numInfected <= 0)
				{
					break;
				}
			}
		}
		
		for(%a = 0; %a < %mini.numMembers; %a++)
		{
			%infClient = %mini.member[%a];
			
			if(!%infClient.isZombie)
			{
				%infClient.zombieVersusInRow--;
			}
		}
	}
	
	return true;
}