$ZAPT_Temp::Mutation::Name = "Infection";
$ZAPT_Temp::Mutation::uiName = "Infection";
$ZAPT_Temp::Mutation::Bots = true;
$ZAPT_Temp::Mutation::HumanRespawn = true;
$ZAPT_Temp::Mutation::Saferooms = true;

function Mutation_Infection_Assemble(%mini)
{
	if(%mini.ZAPT_Outbreak)
	{
		if(mFloor(%mini.ZAPT_Time_Outbreak) < 0)
		{
			%mini.ZAPT_Time_Outbreak = 30;
		}
		
		%mini.zombieOutbreakSched = %mini.schedule(%mini.ZAPT_Time_Outbreak * 1000, "zombieOutbreak");
	}
	
	if(%mini.numMembers == 1 && !%mini.zombieAssembledOnce)
	{
		%mini.messageAll('', "<color:ffffaa>You are the Last " @ (%mini.member[0].chest ? "Woman" : "Man") @ " on Earth. Certain zombies are disabled until others join.");
	}
	
	return true;
}

function Mutation_Infection_ClearZombies(%mini)
{
	return false;
}

function Mutation_Infection_Stress(%mini)
{
	return "";
}

function Mutation_Infection_Time(%mini)
{
	return false;
}