// ============================================================
// Project				:	ZAPT
// Author				:	Iban
// Description			:	Object Creation
// ============================================================
// Table of Contents
// 
// 1. Damage Types
// 2. Brick Related
// 3. Director
// 4. Hacks
// 5. Pretty Stuff
// 6. Item Stuff
// 7. Zombies
// ============================================================

// ============================================================
// Section 1 : Damage Types
// ============================================================
if($DamageType::Burning $= "")
{
	eval("AddDamageType(\"Burning\", '<bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Fire> %1', '%2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Fire> %1', 0.2, 1);");
}

if($DamageType::BurningLeaper $= "")
{
	eval("AddDamageType(\"BurningLeaper\", 'Leaper <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Fire> <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Leaper> %1', 'Leaper %2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Fire> <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Leaper> %1', 1, 1);");
}

if($DamageType::ConsumerExplosion $= "")
{
	eval("AddDamageType(\"ConsumerExplosion \", '<bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Consumer> %1', 'Consumer %2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Consumer> %1', 1, 1);");
}

if($DamageType::ConsumerSwarm $= "")
{
	eval("AddDamageType(\"ConsumerSwarm \", 'Consumer Swarm <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Consumer> <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Zombies> %1', 'Consumer %2 Swarm <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Consumer> <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Zombies> %1', 1, 1);");
}

if($DamageType::LeaperJump $= "")
{
	eval("AddDamageType(\"LeaperJump\", 'Leaper <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Leaper> %1', 'Leaper %2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Leaper> %1', 1, 1);");
}

if($DamageType::JockeyRide $= "")
{
	eval("AddDamageType(\"JockeyRide\", 'Jockey <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Jockey> %1', 'Jockey %2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Jockey> %1', 1, 1);");
}

if($DamageType::Pipebomb $= "")
{
	eval("AddDamageType(\"Pipebomb\", '<bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Pipebomb> %1', '%2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Pipebomb> %1', 1, 1);");
}

if($DamageType::SmasherRam $= "")
{
	eval("AddDamageType(\"SmasherRam\", 'Smasher <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Smasher> %1', 'Smasher %2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Smasher> %1', 1, 1);");
}

if($DamageType::SmokerStrangle $= "")
{
	eval("AddDamageType(\"SmokerStrangle\", 'Smoker <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Smoker> %1', 'Smoker %2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Smoker> %1', 1, 1);");
}

if($DamageType::SpitterAcid $= "")
{
	eval("AddDamageType(\"SpitterAcid\", 'Spitter <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Acid> %1', 'Spitter %2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Acid> %1', 1, 1);");
}

if($DamageType::TankPunch $= "")
{
	eval("AddDamageType(\"TankPunch\", 'Tank <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Tank> %1', 'Tank %2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Tank> %1', 1, 1);");
}

if($DamageType::Witch $= "")
{
	eval("AddDamageType(\"Witch\", 'The Witch <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Witch> %1', 'Witch %2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Witch> %1', 1, 1);");
}

if($DamageType::Zombies $= "")
{
	eval("AddDamageType(\"Zombies\", 'Zombie Horde <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Zombies> %1', 'Zombie %2 <bitmap:" @ $ZAPT::FilePath::Icons @ "CI_Zombies> %1', 1, 1);");
}

// ============================================================
// Section 2 : Brick Related
// ============================================================
// Bricks
if(!isObject(ZombieSafeRoomBrick))
{
	datablock fxDTSBrickData(ZombieSafeRoomBrick : brick16x16FData)
	{
		iconName = $ZAPT::FilePath::Icons @ "Icon_Safehouse";
		
		category = "Special";
		subCategory = "Zombies";
		
		uiName = "Saferoom";
		
		triggerDatablock = "ZombieTrigger";
		
		triggerSize = "16 16" SPC (mFloor($ZAPT::SaferoomHeight) > 0 ? $ZAPT::SaferoomHeight : 15);
	};
}

if(!isObject(ZombieSpawn))
{
	datablock fxDTSBrickData(ZombieSpawn : brickSpawnPointData)
	{
		category = "Special";
		subCategory = "Zombies";
		brickFile = $ZAPT::FilePath::Bricks @ "zombieSpawnPoint.blb";
		uiName = "Zombie Spawn";
		iconName = $ZAPT::FilePath::Icons @ "Icon_ZombieSpawn";
		specialBrickType = "VehicleSpawn";
		
		isZombieSpawn = true;
		isZombieNormSpawn = true;
		isZombieMobSpawn = false;
		isZombieTankSpawn = false;
	};
}

if(!isObject(ZombieSpawnMob))
{
	datablock fxDTSBrickData(ZombieSpawnMob : brickSpawnPointData)
	{
		category = "Special";
		subCategory = "Zombies";
		brickFile = $ZAPT::FilePath::Bricks @ "zombieSpawnPoint.blb";
		uiName = "Zombie Mob Spawn";
		iconName = $ZAPT::FilePath::Icons @ "Icon_ZombieSpawn";
		specialBrickType = "";
		
		isZombieSpawn = true;
		isZombieNormSpawn = false;
		isZombieMobSpawn = true;
		isZombieTankSpawn = false;
	};
}

if(!isObject(ZombieSpawnTank))
{
	datablock fxDTSBrickData(ZombieSpawnTank : brickSpawnPointData)
	{
		category = "Special";
		subCategory = "Zombies";
		brickFile = $ZAPT::FilePath::Bricks @ "tankSpawnPoint.blb";
		uiName = "Tank Spawn";
		iconName = $ZAPT::FilePath::Icons @ "Icon_TankSpawn";
		specialBrickType = "";
		
		isZombieSpawn = true;
		isZombieNormSpawn = false;
		isZombieMobSpawn = false;
		isZombieTankSpawn = true;
	};
}

// ScriptObjects
if(!isObject(ZombieEvents))
{
	new ScriptObject(ZombieEvents);
}

if(!isObject(ZombieFriends))
{
	new ScriptObject(ZombieFriends);
}

if(!isObject(ZombieMutations))
{
	new ScriptObject(ZombieMutations)
	{
		count = 0;
	};
}

// Triggers
if(!isObject(ZombieTrigger))
{
	datablock triggerData(ZombieTrigger)
	{
		tickPeriodMS = 500;
	};
}

// ============================================================
// Section 3 : Director
// ============================================================
if(!isObject(ZombieDirector))
{
	new ScriptObject(ZombieDirector)
	{
		// SimSets and ScriptObjects
		counter			= "ZombieKillCount";
		distractKeeper	= "ZombieKeeperDistraction";
		mobKeeper		= "ZombieKeeperMob";
		mobZKeeper		= "ZombieKeeperMobZ";
		safehouseKeeper	= "ZombieKeeperSafehouse";
		tankKeeper		= "ZombieKeeperTank";
		zombieKeeper	= "ZombieKeeper";
		
		// Stress Calculators
		calcs	= 7;
		calc[0]	= "getStressHealth"		TAB 100;
		calc[1]	= "getStressTime"		TAB 75;
		calc[2]	= "getStressPlayers"	TAB 50;
		calc[3]	= "getStressCamping"	TAB 50;
		calc[4]	= "getStressPanic"		TAB 100;
		calc[5]	= "getStressDeaths"		TAB 100;
		calc[6]	= "getStressSafe"		TAB 50;
	};
	
	ZombieDirector.schedule(32, "direct");
}

if(!isObject(ZombieKillCount))
{
	ZombieDirector.counter = new ScriptObject(ZombieKillCount)
	{
		killers = 0;
	};
}

if(!isObject(ZombieEvents))
{
	new ScriptObject(ZombieEvents)
	{
		brickKeeper	= "ZombieKeeperBrick";
	};
}

if(!isObject(ZombieKeeper))
{
	ZombieDirector.zombieKeeper = new SimSet(ZombieKeeper);
}

if(!isObject(ZombieKeeperBrick))
{
	ZombieEvents.brickKeeper = new SimSet(ZombieKeeperBrick);
}

if(!isObject(ZombieKeeperDistraction))
{
	ZombieDirector.distractKeeper = new SimSet(ZombieKeeperDistraction);
}

if(!isObject(ZombieKeeperMob))
{
	ZombieDirector.mobKeeper = new SimSet(ZombieKeeperMob);
}

if(!isObject(ZombieKeeperMobZ))
{
	ZombieDirector.mobZKeeper = new SimSet(ZombieKeeperMobZ);
}

if(!isObject(ZombieKeeperSafehouse))
{
	ZombieDirector.safehouseKeeper = new SimSet(ZombieKeeperSafehouse);
}

if(!isObject(ZombieKeeperTank))
{
	ZombieDirector.tankKeeper = new SimSet(ZombieKeeperTank);
}

// ============================================================
// Section 4 : Hacks
// ============================================================
if(!isObject(ZombieCrouchHack))
{
	datablock ShapeBaseImageData(ZombieCrouchHack)
	{
		shapeFile = "base/data/shapes/empty.dts";
		emap = false;
		mountPoint = 3;
	};
}

if(!isObject(ZombieJumpHack))
{
	datablock ShapeBaseImageData(ZombieJumpHack)
	{
		shapeFile = "base/data/shapes/empty.dts";
		emap = false;
		mountPoint = 2;
	};
}

if(!isObject(ZombieSpecialHack))
{
	datablock ShapeBaseImageData(ZombieSpecialHack)
	{
		shapeFile = "base/data/shapes/empty.dts";
		emap = false;
		mountPoint = 4;
	};
}

// ============================================================
// Section 5 : Pretty Stuff
// ============================================================
// Lights
if(!isObject(ZombieWitchLight))
{
	datablock fxLightData(ZombieWitchLight)
	{
		uiName = "Witch Light";
		
		LightOn = true;
		radius = 10;
		brightness = 8;
		color = "0.75 0 0 1";
		
		flareOn = false;
	};
}

// Sounds
if(!isObject(Beep_EKG_Sound))
{
	datablock AudioProfile(Beep_EKG_Sound)
	{
		filename = $ZAPT::FilePath::Sounds @ "sfx.beep.wav";
		description = AudioClosest3d;
		preload = false;
	};
}

if(!isObject(ZombieCrunchSound))
{
	datablock AudioProfile(ZombieCrunchSound)
	{
		filename = $ZAPT::FilePath::Sounds @ "sfx.crunch.wav";
		description = AudioClosest3d;
		preload = false;
	};
}

if(!isObject(ZombiePunchExplosionSound))
{
	datablock AudioProfile(ZombiePunchExplosionSound)
	{
		filename = $ZAPT::FilePath::Sounds @ "sfx.punch.wav";
		description = AudioClosest3d;
		preload = false;
	};
}

// Particles
if(!isObject(ZombieBeaconParticle))
{
	datablock ParticleData(ZombieBeaconParticle)
	{
		dragCoefficient = "2.99998";
		windCoefficient = "0";
		gravityCoefficient = "-0.50061";
		inheritedVelFactor = "0";
		constantAcceleration = "0";
		lifetimeMS = "1900";
		lifetimeVarianceMS = "300";
		spinSpeed = "10";
		spinRandomMin = "-50";
		spinRandomMax = "50";
		useInvAlpha = "1";
		animateTexture = "0";
		framesPerSec = "1";
		textureName = "base/data/particles/cloud";
		animTexName[0] = "base/data/particles/cloud";
		colors[0] = "0.60 0.80 0.19 1.00";
		colors[1] = "0.00 0.00 0.00 0.00";
		colors[2] = "0.87 1.00 0.00 0.30";
		colors[3] = "0.87 1.00 0.00 0.30";
		sizes[0] = "3.99499";
		sizes[1] = "9.99817";
		sizes[2] = "1";
		sizes[3] = "1";
		times[0] = "0";
		times[1] = "1";
		times[2] = "2";
		times[3] = "2";
	};
}

if(!isObject(ZombieBileCoatParticle))
{
	datablock ParticleData(ZombieBileCoatParticle)
	{
		textureName				= "base/data/particles/cloud";
		dragCoefficient			= 0.0;
		gravityCoefficient		= 0.5;
		inheritedVelFactor		= 0.0;
		windCoefficient			= 0;
		constantAcceleration	= 3.0;
		lifetimeMS				= 600;
		lifetimeVarianceMS		= 100;
		spinSpeed				= 0;
		spinRandomMin			= -90.0;
		spinRandomMax			=  90.0;
		useInvAlpha				= true;
		
		colors[0]	= "0.60 0.80 0.19 1.00";
		colors[1]	= "0.00 0.00 0.00 0.00";
		colors[2]	= "0.87 1.00 0.00 0.30";
		colors[3]	= "0.87 1.00 0.00 0.30";
		
		sizes[0]	= 0.0;
		sizes[1]	= 3.0;
		sizes[2]	= 2.0;
		sizes[3]	= 2.0;
		
		times[0]	= 0.0;
		times[1]	= 0.2;
		times[2]	= 1.0;
		times[3]	= 1.0;
	};
}

if(!isObject(ZombieBileTrailParticle))
{
	datablock ParticleData(ZombieBileTrailParticle)
	{
		dragCoefficient      = 5;
		gravityCoefficient   = 0.0;
		inheritedVelFactor   = 0.1;
		constantAcceleration = 0.0;
		lifetimeMS           = 600;
		lifetimeVarianceMS   = 400;
		textureName          = "base/data/particles/cloud";
		spinSpeed		= 0.0;
		spinRandomMin		= -0.0;
		spinRandomMax		= 0.0;
		colors[0] = "0.60 0.80 0.19 1.00";
		colors[1] = "0.00 0.00 0.00 0.00";
		colors[2] = "0.87 1.00 0.00 0.30";
		colors[3] = "0.87 1.00 0.00 0.30";
		sizes[0]      = 0.5;
		sizes[1]      = 0.35;
		sizes[1]      = 0.25;
		sizes[2]      = 0.0;
		times[0] = 0;
		times[1] = 0.5;
		times[2] = 1.0;
	};
}

if(!isObject(PlayerNapalmFireParticle))
{
	datablock ParticleData(PlayerNapalmFireParticle)
	{
		textureName				= "base/data/particles/cloud";
		dragCoefficient			= 0.0;
		gravityCoefficient		= -1.0;
		inheritedVelFactor		= 0.0;
		windCoefficient			= 0;
		constantAcceleration	= 3.0;
		lifetimeMS				= 1200;
		lifetimeVarianceMS		= 100;
		spinSpeed				= 0;
		spinRandomMin			= -90.0;
		spinRandomMax			=  90.0;
		useInvAlpha				= false;
		
		colors[0]	= "1.0 1.0 0.3 0.0";
		colors[1]	= "1.0 1.0 0.3 1.0";
		colors[2]	= "0.6 0.0 0.0 0.0";
		
		sizes[0]	= 0.0;
		sizes[1]	= 2.0;
		sizes[2]	= 1.0;
		
		times[0]	= 0.0;
		times[1]	= 0.2;
		times[2]	= 1.0;
	};
}

if(!isObject(ZombiePipebombSparksParticle))
{
	datablock ParticleData(ZombiePipebombSparksParticle)
	{
		textureName          = "base/data/particles/dot";
		dragCoefficient      = 0.0;
		gravityCoefficient   = -3.0;
		inheritedVelFactor   = 0.0;
		windCoefficient      = 0;
		constantAcceleration = -3.0;
		lifetimeMS           = 400;
		lifetimeVarianceMS   = 050;
		spinSpeed     = 0;
		spinRandomMin = -90.0;
		spinRandomMax =  90.0;
		useInvAlpha   = false;

		colors[0]	= "1   1   0.3 0.0";
		colors[1]	= "1   1   0.3 1.0";
		colors[2]	= "0.6 0.0 0.0 0.0";

		sizes[0]	= 0.0;
		sizes[1]	= 0.2;
		sizes[2]	= 0.12;

		times[0]	= 0.0;
		times[1]	= 0.2;
		times[2]	= 1.0;
	};
}

if(!isObject(ZombiePunchParticle1))
{
	datablock ParticleData(ZombiePunchParticle1)
	{
		dragCoefficient			= 3.0;
		windCoefficient			= 0.0;
		gravityCoefficient		= 0.5;
		inheritedVelFactor		= 0.0;
		constantAcceleration	= 0.0;
		lifetimeMS				= 900;
		lifetimeVarianceMS		= 300;
		spinSpeed				= 10.0;
		spinRandomMin			= -50.0;
		spinRandomMax			= 50.0;
		useInvAlpha				= true;
		animateTexture			= false;

		textureName				= "base/data/particles/cloud";

		// Interpolation variables
		colors[0]	= "0.3 0.3 0.2 0.9";
		colors[1]	= "0.2 0.2 0.2 0.0";
		sizes[0]	= 4.0;
		sizes[1]	= 7.0;
		times[0]	= 0.0;
		times[1]	= 1.0;
	};
}

if(!isObject(ZombiePunchParticle2))
{
	datablock ParticleData(ZombiePunchParticle2)
	{
		dragCoefficient		= 0.1;
		windCoefficient		= 0.0;
		gravityCoefficient	= 2.0;
		inheritedVelFactor	= 0.0;
		constantAcceleration	= 0.0;
		lifetimeMS		= 1000;
		lifetimeVarianceMS	= 500;
		spinSpeed		= 10.0;
		spinRandomMin		= -50.0;
		spinRandomMax		= 50.0;
		useInvAlpha		= true;
		animateTexture		= false;

		textureName		= "base/data/particles/chunk";

		// Interpolation variables
		colors[0]	= "0.0 0.0 0.0 1.0";
		colors[1]	= "0.0 0.0 0.0 0.0";
		sizes[0]	= 0.5;
		sizes[1]	= 0.5;
		times[0]	= 0.0;
		times[1]	= 1.0;
	};
}

if(!isObject(ZombieSmokerDeathParticle))
{
	datablock ParticleData(ZombieSmokerDeathParticle)
	{
		dragCoefficient			= 0.0;
		gravityCoefficient		= 0.0;
		inheritedVelFactor		= 0.0;
		constantAcceleration	= 0.0;
		lifetimeMS				= 10000;
		lifetimeVarianceMS		= 2500;
		textureName				= "base/data/particles/cloud";
		
		spinSpeed			= 0.0;
		spinRandomMin		= -30.0;
		spinRandomMax		= 30.0;
		
		colors[0]	= "0.43 0.50 0.56 0.0";
		colors[1]	= "0.43 0.50 0.56 0.5";
		colors[2]	= "0.43 0.50 0.56 0.0";
		colors[3]	= "0.43 0.50 0.56 0.0";
		
		sizes[0]	= 1.5;
		sizes[1]	= 1.9;
		sizes[2]	= 1.6;
		sizes[3]	= 1.0;
		
		times[0]	= 0.0;
		times[1]	= 0.2;
		times[2]	= 1.0;
		times[3]	= 2.0;
		
		useInvAlpha = true;
	};
}

if(!isObject(ZombieSmokerTrailParticle))
{
	datablock ParticleData(ZombieSmokerTrailParticle)
	{
		dragCoefficient			= 4;
		gravityCoefficient		= -0.75;
		inheritedVelFactor		= 0.0;
		constantAcceleration	= 0.0;
		lifetimeMS				= 1500;
		lifetimeVarianceMS		= 500;
		textureName				= "base/data/particles/chunk";
		
		useInvAlpha			= true;
		spinSpeed			= 0.0;
		spinRandomMin		= -150.0;
		spinRandomMax		= 150.0;
		
		colors[0]	= "0.10 0.40 0.50 0.0";
		colors[1]	= "0.16 0.18 0.21 1.0";
		colors[2]	= "0.00 0.00 0.00 0.0";
		
		sizes[0]	= 0.15;
		sizes[1]	= 0.15;
		sizes[2]	= 0.15;
		
		times[0]	= 0.1;
		times[1]	= 0.5;
		times[2]	= 1.0;
	};
}

// Emitters
if(!isObject(ZombieBeaconEmitter))
{
	datablock ParticleEmitterData(ZombieBeaconEmitter)
	{
		ejectionPeriodMS = "7";
		periodVarianceMS = "0";
		ejectionVelocity = "8";
		velocityVariance = "1";
		ejectionOffset = "0";
		thetaMin = "0";
		thetaMax = "90";
		phiReferenceVel = "0";
		phiVariance = "360";
		overrideAdvance = "0";
		orientParticles = "0";
		orientOnVelocity = "1";
		particles = "ZombieBeaconParticle";
		lifetimeMS = "21";
		lifetimeVarianceMS = "0";
		useEmitterSizes = "0";
		useEmitterColors = "0";
		uiName = "Consumer Explosion";
		doFalloff = "1";
		doDetail = "1";
		emitterNode = "TenthEmitterNode";
	};
}

if(!isObject(ZombieBileCoatEmitter))
{
	datablock ParticleEmitterData(ZombieBileCoatEmitter)
	{
		className = "ParticleEmitterData";
		ejectionPeriodMS = "50";
		periodVarianceMS = "4";
		ejectionVelocity = "0";
		velocityVariance = "0";
		ejectionOffset = "0";
		thetaMin = "0";
		thetaMax = "5";
		phiReferenceVel = "0";
		phiVariance = "360";
		overrideAdvance = "0";
		orientParticles = "0";
		orientOnVelocity = "1";
		particles = "ZombieBileCoatParticle";
		lifetimeMS = "0";
		lifetimeVarianceMS = "0";
		useEmitterSizes = "0";
		useEmitterColors = "0";
		uiName = "Bile";
		doFalloff = "1";
		doDetail = "1";
	};
}

if(!isObject(ZombieBileTrailEmitter))
{
	datablock ParticleEmitterData(ZombieBileTrailEmitter)
	{
	   ejectionPeriodMS = 3;
	   periodVarianceMS = 0;
	   ejectionVelocity = 4;
	   velocityVariance = 2.0;
	   ejectionOffset   = 0.0;
	   thetaMin         = 0;
	   thetaMax         = 90;
	   phiReferenceVel  = 0;
	   phiVariance      = 360;
	   overrideAdvance = false;
	   particles = "ZombieBileTrailParticle";

	   useEmitterColors = true;

	   uiName = "";
	};
}

if(!isObject(PlayerNapalmFireEmitter))
{
	datablock ParticleEmitterData(PlayerNapalmFireEmitter)
	{
		ejectionPeriodMS	= 5;
		periodVarianceMS	= 4;
		ejectionVelocity	= 0;
		ejectionOffset		= 1.00;
		velocityVariance	= 0.0;
		thetaMin			= 30;
		thetaMax			= 90;
		phiReferenceVel		= 0;
		phiVariance			= 360;
		overrideAdvance		= false;
		
		particles = playerNapalmFireParticle;  
		
		uiName = "Player Napalm"; 
	};
}

if(!isObject(ZombiePipebombSparkEmitter))
{
	datablock ParticleEmitterData(ZombiePipebombSparkEmitter)
	{
		ejectionPeriodMS = 14;
		periodVarianceMS = 4;
		ejectionVelocity = 3;
		ejectionOffset   = 0.00;
		velocityVariance = 0.0;
		thetaMin         = 0;
		thetaMax         = 5;
		phiReferenceVel  = 0;
		phiVariance      = 360;
		overrideAdvance = false;
		
		particles = ZombiePipebombSparksParticle;   
		
		uiName = "Pipebomb Sparks";
	};
}

if(!isObject(ZombiePunchEmitter1))
{
	datablock ParticleEmitterData(ZombiePunchEmitter1)
	{
	   ejectionPeriodMS = 7;
	   periodVarianceMS = 0;
	   lifeTimeMS	   = 21;
	   ejectionVelocity = 8;
	   velocityVariance = 1.0;
	   ejectionOffset   = 0.0;
	   thetaMin         = 0;
	   thetaMax         = 90;
	   phiReferenceVel  = 0;
	   phiVariance      = 360;
	   overrideAdvance = false;
	   particles = "ZombiePunchParticle1";

	   uiName = "Spear Smoke";
	   emitterNode = TenthEmitterNode;
	};
}

if(!isObject(ZombiePunchEmitter2))
{
	datablock ParticleEmitterData(ZombiePunchEmitter2)
	{
	   ejectionPeriodMS = 1;
	   periodVarianceMS = 0;
	   lifetimeMS       = 7;
	   ejectionVelocity = 15;
	   velocityVariance = 5.0;
	   ejectionOffset   = 0.0;
	   thetaMin         = 0;
	   thetaMax         = 90;
	   phiReferenceVel  = 0;
	   phiVariance      = 360;
	   overrideAdvance = false;
	   particles = "ZombiePunchParticle2";

	   useEmitterColors = true;
	   uiName = "Spear Chunk";
	   emitterNode = HalfEmitterNode;
	};
}

if(!isObject(ZombieSmokerDeathEmitter))
{
	datablock ParticleEmitterData(ZombieSmokerDeathEmitter)
	{
		className = "ParticleEmitterData";
		ejectionPeriodMS = "25";
		periodVarianceMS = "4";
		ejectionVelocity = "1.19";
		velocityVariance = "0";
		ejectionOffset = "0.39";
		thetaMin = "0";
		thetaMax = "90";
		phiReferenceVel = "0";
		phiVariance = "360";
		overrideAdvance = "0";
		orientParticles = "0";
		orientOnVelocity = "1";
		particles = "ZombieSmokerDeathParticle";
		lifetimeMS = "0";
		lifetimeVarianceMS = "0";
		useEmitterSizes = "0";
		useEmitterColors = "1";
		uiName = "";
		doFalloff = "1";
		doDetail = "1";
	};
}

if(!isObject(ZombieSmokerTrailEmitter))
{
	datablock ParticleEmitterData(ZombieSmokerTrailEmitter)
	{
		lifeTimeMS = 0;
		lifeTimeVarianceMS = 0;
		
		ejectionPeriodMS	= 10;
		periodVarianceMS	= 0;
		ejectionVelocity	= 5;
		velocityVariance	= 3;
		ejectionOffset		= 1.50;
		thetaMin			= 0;
		thetaMax			= 90;
		phiReferenceVel		= 0;
		phiVariance			= 360;
		overrideAdvance		= false;
		particles			= ZombieSmokerTrailParticle;
		
		uiName = "";
	};
}

// Explosions
if(!isObject(ZombieBeaconExplosion))
{
	datablock ExplosionData(ZombieBeaconExplosion)
	{
		soundProfile = "vehicleExplosionSound";
		faceViewer = "1";
		particleDensity = "10";
		particleRadius = "1";
		explosionScale = "1 1 1";
		playSpeed = "1";
		emitter[0] = "ZombieBeaconEmitter";
		emitter[1] = "vehicleExplosionEmitter2";
		debrisThetaMin = "0";
		debrisThetaMax = "90";
		debrisPhiMin = "0";
		debrisPhiMax = "360";
		debrisNum = "1";
		debrisNumVariance = "0";
		debrisVelocity = "2";
		debrisVelocityVariance = "0";
		delayMS = "0";
		delayVariance = "0";
		lifetimeMS = "150";
		lifetimeVariance = "0";
		offset = "0";
		times[0] = "0";
		times[1] = "1";
		times[2] = "1";
		times[3] = "1";
		sizes[0] = "1 1 1";
		sizes[1] = "1 1 1";
		sizes[2] = "1 1 1";
		sizes[3] = "1 1 1";
		shakeCamera = "1";
		cameraShakeFalloff = "1";
		camShakeFreq = "7 8 7";
		camShakeAmp = "1 1 1";
		camShakeDuration = "0.5";
		camShakeRadius = "15";
		camShakeFalloff = "10";
		lightStartRadius = "13.7255";
		lightEndRadius = "2.7451";
		lightStartColor = "0.6 0.8 0.19 1.0";
		lightEndColor = "0.87 1.0 0.0 0.3";
		radiusDamage = "100";
		damageRadius = "8";
		impulseRadius = "0";
		impulseForce = "0";
	};
}

if(!isObject(ZombiePipebombExplosion))
{
	datablock ExplosionData(ZombiePipebombExplosion)
	{
		className = "ExplosionData";
		soundProfile = "vehicleExplosionSound";
		faceViewer = "1";
		particleDensity = "10";
		particleRadius = "1";
		explosionScale = "1 1 1";
		playSpeed = "1";
		emitter[0] = "vehicleExplosionEmitter";
		emitter[1] = "vehicleExplosionEmitter2";
		debrisThetaMin = "0";
		debrisThetaMax = "90";
		debrisPhiMin = "0";
		debrisPhiMax = "360";
		debrisNum = "1";
		debrisNumVariance = "0";
		debrisVelocity = "2";
		debrisVelocityVariance = "0";
		delayMS = "0";
		delayVariance = "0";
		lifetimeMS = "150";
		lifetimeVariance = "0";
		offset = "0";
		times[0] = "0";
		times[1] = "1";
		times[2] = "1";
		times[3] = "1";
		sizes[0] = "1 1 1";
		sizes[1] = "1 1 1";
		sizes[2] = "1 1 1";
		sizes[3] = "1 1 1";
		shakeCamera = "1";
		cameraShakeFalloff = "1";
		camShakeFreq = "7 8 7";
		camShakeAmp = "1 1 1";
		camShakeDuration = "0.5";
		camShakeRadius = "15";
		camShakeFalloff = "10";
		lightStartRadius = "13.7255";
		lightEndRadius = "2.7451";
		lightStartColor = "0.897638 0.299213 0.094488 1.000000";
		lightEndColor = "0.000000 0.000000 0.000000 1.000000";
			radiusDamage = "200";
			damageRadius = "8";
			impulseRadius = "12";
			impulseForce = "850";
	};
}

if(!isObject(ZombiePunchExplosion))
{
	datablock ExplosionData(ZombiePunchExplosion)
	{
	   lifeTimeMS = 150;

	   soundProfile = "ZombiePunchExplosionSound";

	   emitter[0] = "ZombiePunchEmitter1";
	   emitter[1] = "ZombiePunchEmitter2";

	   faceViewer     = true;
	   explosionScale = "1 1 1";

	   shakeCamera = true;
	   camShakeFreq = "7.0 8.0 7.0";
	   camShakeAmp = "1.0 1.0 1.0";
	   camShakeDuration = 0.5;
	   camShakeRadius = 15.0;

	   // Dynamic light
	   lightStartRadius = 4;
	   lightEndRadius = 3;
	   lightStartColor = "0.45 0.3 0.1";
	   lightEndColor = "0 0 0";

	   //impulse
	   impulseRadius = 3.5;
	   impulseForce = 2000;

	   //radius damage
	   radiusDamage        = 0;
	   damageRadius        = 0;
	};
}

// ============================================================
// Section 6 : Item Stuff
// ============================================================
// Projectiles
if(!isObject(ZombieBeaconProjectile))
{
	datablock ProjectileData(ZombieBeaconProjectile)
	{
		projectileShapeName = "base/data/shapes/empty.dts";
		directDamage        = 0;
		
		brickExplosionImpact = false;
		
		impactImpulse		= 0;
		verticalImpulse		= 0;
		explosion           = ZombieBeaconExplosion;
		particleEmitter     = "";
		
		muzzleVelocity      = 90;
		velInheritFactor    = 1;
		
		armingDelay         = 0;
		lifetime            = 32;
		fadeDelay           = 32;
		isBallistic			= false;
		
		hasLight			= false;
	};
}

if(!isObject(ZombieBileProjectile))
{
	datablock ProjectileData(ZombieBileProjectile)
	{
		projectileShapeName = "base/data/shapes/empty.dts";
		explosion           = "";
		bounceExplosion     = "";
		particleEmitter     = ZombieBileTrailEmitter;
		explodeOnDeath		= true;

		brickExplosionRadius = 0;
		brickExplosionImpact = 0;
		brickExplosionForce  = 0;             
		brickExplosionMaxVolume = 0; 
		brickExplosionMaxVolumeFloating = 0;

		sound = "";

		muzzleVelocity      = 65;
		velInheritFactor    = 1.0;

		armingDelay         = 0;
		lifetime            = 5000;
		fadeDelay           = 4500;
		bounceElasticity    = 0.90;
		bounceFriction      = 0.00;
		isBallistic         = true;
		gravityMod          = 1.0;
		hasLight			= false;
	};
}

if(!isObject(ZombiePipebombProjectile))
{
	datablock ProjectileData(ZombiePipebombProjectile)
	{
		projectileShapeName				= $ZAPT::FilePath::Shapes @ "pipebombProj.1.dts";
		directDamage					= 0;
		directDamageType				= $DamageType::Pipebomb;
		radiusDamageType				= $DamageType::Pipebomb;
		
		brickExplosionRadius			= 0;
		brickExplosionImpact			= false;
		brickExplosionForce				= 0;
		brickExplosionMaxVolume			= 0;
		brickExplosionMaxVolumeFloating	= 0;
		
		explodeOnDeath					= true;
		impactImpulse					= 400;
		verticalImpulse					= 400;
		explosion						= ZombiePipebombExplosion;
		particleEmitter					= ZombiePipebombSparkEmitter;
		
		muzzleVelocity					= 25;
		velInheritFactor				= 0;
		
		armingDelay						= 9750;
		lifetime						= 10000;
		fadeDelay						= 10000;
		bounceElasticity				= 0.4;
		bounceFriction					= 0.3;
		isBallistic						= true;
		gravityMod						= 1.0;
		
		hasLight						= true;
		lightRadius						= 6.0;
		lightColor						= "1.0 0 0";
		
		uiName							= "Pipebomb";
		zombieDistraction				= true;
		zombieMakeNoise					= true;
	};
}

if(!isObject(ZombiePunchProjectile))
{
	datablock ProjectileData(ZombiePunchProjectile)
	{
	   projectileShapeName	= "base/data/shapes/empty.dts";
	   directDamage			= 0;
	   directDamageType		= $DamageType::TankPunch;
	   radiusDamageType		= $DamageType::TankPunch;
	   impactImpulse		= 0;
	   verticalImpulse		= 0;
	   explosion			= "ZombiePunchExplosion";
	   particleEmitter		= "";
	   
	   brickExplosionImpact = false;
		
	   muzzleVelocity		= 50;
	   velInheritFactor		= 1;
		
	   armingDelay			= 0;
	   lifetime				= 20000;
	   fadeDelay			= 19500;
	   bounceElasticity		= 0;
	   bounceFriction		= 0;
	   isBallistic			= true;
	   gravityMod			= 0.50;
		
	   hasLight				= false;

	   uiName				= "Tank Punch";
	};
}

if(!isObject(ZombieSmashProjectile))
{
	datablock ProjectileData(ZombieSmashProjectile)
	{
		projectileShapeName	= "base/data/shapes/empty.dts";
		directDamage		= 0;
		directDamageType	= $DamageType::Generic;
		radiusDamageType	= $DamageType::Generic;
		impactImpulse		= 0;
		verticalImpulse		= 0;
		explosion			= ZombiePunchExplosion;
		particleEmitter		= "";
		sound = "";
		
		brickExplosionRadius			= 2;	
		brickExplosionImpact			= true;	//destroy a brick if we hit it directly?
		brickExplosionForce				= 20;	
		brickExplosionMaxVolume			= 30;	//max volume of bricks that we can destroy
		brickExplosionMaxVolumeFloating	= 60;	//max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)
		
		muzzleVelocity      = 10;
		velInheritFactor    = 0.0;
		
		armingDelay			= 00;
		lifetime			= 10;
		fadeDelay			= 100;
		bounceElasticity	= 0.5;
		bounceFriction		= 0.20;
		isBallistic			= false;
		gravityMod			= 0.0;
		
		hasLight			= false;
		lightRadius			= 5.0;
		lightColor			= "1 0.5 0.0";
	};
}

// Items
if(!isObject(ZombiePipebombItem))
{
	datablock ItemData(ZombiePipebombItem)
	{
		category = "Weapon";
		className = "Weapon";
		
		// Basic Item Properties
		shapeFile = $ZAPT::FilePath::Shapes @ "pipebomb.3.dts";
		mass = 1;
		density = 0.2;
		elasticity = 0.2;
		friction = 0.6;
		emap = true;
		
		// GUI Stuff
		uiName = "Pipebomb";
		iconName = $ZAPT::FilePath::Icons @ "Icon_Pipebomb";
		doColorShift = false;
		
		// Script Properties
		image = ZombiePipebombImage;
		canDrop = true;
	};
}

// Images
if(!isObject(ZombieBileImage))
{
	datablock ShapeBaseImageData(ZombieBileImage)
	{
		shapeFile = "base/data/shapes/empty.dts";
		emap = false;

		mountPoint = $BackSlot;
		offset = "0 0 -0.25";

		stateName[0]				= "Ready";
		stateTimeoutValue[0]		= 0.01;
		stateTransitionOnTimeout[0]	= "FireA";

		stateName[1]				= "FireA";
		stateEmitter[1]				= ZombieBileCoatEmitter;
		stateEmitterTime[1]			= 0.9;
		stateTimeoutValue[1]		= 0.9;
		stateTransitionOnTimeout[1]	= "Done";
		stateWaitForTimeout[1]		= true;

		stateName[2]				= "Done";
		stateTimeoutValue[2]		= 0.01;
		stateTransitionOnTimeout[2]	= "FireA";
	};
}

if(!isObject(ZombieBloodImage))
{
	datablock ShapeBaseImageData(ZombieBloodImage)
	{
		shapeFile = "base/data/shapes/empty.dts";
		emap = false;

		mountPoint = $WeaponSlot;
		offset = "0 0 0";

		stateName[0]				= "Ready";
		stateTimeoutValue[0]		= 0.01;
		stateTransitionOnTimeout[0]	= "FireA";

		stateName[1]				= "FireA";
		stateEmitter[1]				= ZombieBileCoatEmitter;
		stateEmitterTime[1]			= 0.9;
		stateTimeoutValue[1]		= 0.9;
		stateTransitionOnTimeout[1]	= "Done";
		stateWaitForTimeout[1]		= true;

		stateName[2]				= "Done";
		stateTimeoutValue[2]		= 0.01;
		stateTransitionOnTimeout[2]	= "FireA";
	};
}

if(!isObject(ZombieClawLeftImage))
{
	datablock ShapeBaseImageData(ZombieClawLeftImage)
	{
		shapeFile = $ZAPT::FilePath::Shapes @ "claw_left.1.dts";
		emap = true;
		mountPoint = 1;
		offset = "0 -0.25 0.2";
		eyeOffset = "0 0 0";
		rotation = eulerToMatrix("0 0 0");
		firstPerson = false;
		
		className = "WeaponImage";
		item = "";
		
		armReady = false;
		doColorShift = false;
	};
}

if(!isObject(ZombieClawRightImage))
{
	datablock ShapeBaseImageData(ZombieClawRightImage)
	{
		shapeFile = $ZAPT::FilePath::Shapes @ "claw_right.1.dts";
		emap = true;
		mountPoint = 0;
		offset = "0 -0.25 0.2";
		eyeOffset = "0 0 0";
		rotation = eulerToMatrix("0 0 0");
		firstPerson = false;
		
		className = "WeaponImage";
		item = "";
		
		armReady = true;
		doColorShift = false;
		
		stateName[0]					= "Activate";
		stateTransitionOnTimeout[0]		= "Ready";
		stateTimeoutValue[0]			= 0.2;
		stateSequence[0]				= "ready";
		
		stateName[1]					= "Ready";
		stateTransitionOnTriggerDown[1]	= "Fire";
		
		stateName[2]					= "Fire";
		stateScript[2]					= "onFire";
		stateTransitionOnTriggerUp[2]	= "Ready";
	};
}

if(!isObject(ZombieFistLeftImage))
{
	datablock ShapeBaseImageData(ZombieFistLeftImage)
	{
		shapeFile = $ZAPT::FilePath::Shapes @ "fist_left.1.dts";
		emap = true;
		mountPoint = 1;
		offset = "0 0 0.2";
		eyeOffset = "0 0 0";
		rotation = eulerToMatrix("0 0 0");
		firstPerson = false;
		
		className = "WeaponImage";
		item = "";
		
		armReady = false;
		doColorShift = true;
		colorShiftColor = "0.2 0.2 0.1 1";
	};
}

if(!isObject(ZombieFistRightImage))
{
	datablock ShapeBaseImageData(ZombieFistRightImage)
	{
		shapeFile = $ZAPT::FilePath::Shapes @ "fist_right.1.dts";
		emap = true;
		mountPoint = 0;
		offset = "0 0 0.2";
		eyeOffset = "0 0 0";
		rotation = eulerToMatrix("0 0 0");
		firstPerson = false;
		
		className = "WeaponImage";
		item = "";
		
		armReady = true;
		doColorShift = true;
		colorShiftColor = "0.2 0.2 0.1 1";
		
		stateName[0]					= "Activate";
		stateTransitionOnTimeout[0]		= "Ready";
		stateTimeoutValue[0]			= 0.2;
		stateSequence[0]				= "ready";
		
		stateName[1]					= "Ready";
		stateTransitionOnTriggerDown[1]	= "Fire";
		
		stateName[2]					= "Fire";
		stateScript[2]					= "onFire";
		stateTransitionOnTriggerUp[2]	= "Ready";
	};
}

if(!isObject(ZombieFistSmasherImage))
{
	datablock ShapeBaseImageData(ZombieFistSmasherImage)
	{
		shapeFile = $ZAPT::FilePath::Shapes @ "fist_right.1.dts";
		emap = true;
		mountPoint = 0;
		offset = "0 0 0.2";
		eyeOffset = "0 0 0";
		rotation = eulerToMatrix("0 0 0");
		firstPerson = false;
		
		className = "WeaponImage";
		item = "";
		
		armReady = true;
		doColorShift = true;
		colorShiftColor = "0.6 0.6 0.35 1";
		
		stateName[0]					= "Activate";
		stateTransitionOnTimeout[0]		= "Ready";
		stateTimeoutValue[0]			= 0.2;
		stateSequence[0]				= "ready";
		
		stateName[1]					= "Ready";
		stateTransitionOnTriggerDown[1]	= "Fire";
		
		stateName[2]					= "Fire";
		stateScript[2]					= "onFire";
		stateTransitionOnTriggerUp[2]	= "Ready";
	};
}

if(!isObject(ZombieFistChargingImage))
{
	datablock ShapeBaseImageData(ZombieFistChargingImage : ZombieFistSmasherImage)
	{
		doColorShift = true;
		colorShiftColor = "1 0 0 1";
	};
}

if(!isObject(PlayerNapalmBurnImage))
{
	datablock ShapeBaseImageData(PlayerNapalmBurnImage)
	{
		shapeFile = "base/data/shapes/empty.dts";
		emap = false;

		mountPoint = $HeadSlot;
		offset = "0 0 -2";

		stateName[0]				= "Ready";
		stateTimeoutValue[0]		= 0.01;
		stateTransitionOnTimeout[0]	= "FireA";

		stateName[1]				= "FireA";
		stateEmitter[1]				= playerNapalmFireEmitter;
		stateEmitterTime[1]			= 0.9;
		stateTimeoutValue[1]		= 0.9;
		stateTransitionOnTimeout[1]	= "Done";
		stateWaitForTimeout[1]		= true;

		stateName[2]				= "Done";
		stateTimeoutValue[2]		= 0.01;
		stateTransitionOnTimeout[2]	= "FireA";
	};
}

if(!isObject(ZombiePipebombImage))
{
	datablock ShapeBaseImageData(ZombiePipebombImage)
	{
		shapeFile = $ZAPT::FilePath::Shapes @ "pipebomb.3.dts";
		emap = true;
		mountPoint = 0;
		offset = "0 0 0";
		correctMuzzleVector = true;
		className = "WeaponImage";
		
		item = ZombiePipebombItem;
		ammo = "";
		projectile = ZombiePipebombProjectile;
		projectileType = Projectile;
		
		melee = false;
		armReady = true;
		
		doColorShift = false;
		
		// States
		stateName[0]					= "Activate";
		stateSequence[0]				= "ready";
		stateSound[0]					= weaponSwitchSound;
		stateTimeoutValue[0]			= 0.1;
		stateTransitionOnTimeout[0]		= "Ready";

		stateName[1]					= "Ready";
		stateAllowImageChange[1]		= true;
		stateTransitionOnTriggerDown[1]	= "Charge";

		stateName[2]					= "Charge";
		stateEmitter[2]					= ZombiePipebombSparkEmitter;
		stateEmitterTime[2]				= 999999;
		stateTimeoutValue[2]			= 0.7;
		stateTransitionOnTimeout[2]		= "Charged";
		stateTransitionOnTriggerUp[2]	= "AbortCharge";
		stateScript[2]					= "onCharge";
		stateWaitForTimeout[2]			= true;

		stateName[3]					= "Charged";
		stateAllowImageChange[3]		= false;
		stateEmitter[3]					= ZombiePipebombSparkEmitter;
		stateEmitterTime[3]				= 999999;
		stateTransitionOnTriggerUp[3]	= "Fire";

		stateName[4]					= "Fire";
		stateAllowImageChange[4]		= false;
		stateFire[4]					= true;
		stateScript[4]					= "onFire";
		stateTimeoutValue[4]			= 0.5;
		stateTransitionOnTimeout[4]		= "Done";
		stateWaitForTimeout[4]			= true;
		
		stateName[5]					= "Done";
		stateScript[5]					= "onDone";
		
		stateName[6]					= "AbortCharge";
		stateScript[6]					= "onChargeAbort";
		stateTimeoutValue[6]			= 0;
		stateTransitionOnTimeout[6]		= "Ready";
	};
}

if(!isObject(ZombieSmokeImage))
{
	datablock ShapeBaseImageData(ZombieSmokeImage)
	{
		shapeFile = "base/data/shapes/empty.dts";
		emap = false;

		mountPoint = $BackSlot;
		offset = "0.00 -1.00 0.50";
		rotation = "1 0 0 0";
		
		stateName[0]				= "Ready";
		stateTimeoutValue[0]		= 0.01;
		stateTransitionOnTimeout[0]	= "FireA";

		stateName[1]				= "FireA";
		stateEmitter[1]				= ZombieSmokerTrailEmitter;
		stateEmitterTime[1]			= 0.9;
		stateTimeoutValue[1]		= 0.9;
		stateTransitionOnTimeout[1]	= "Done";
		stateWaitForTimeout[1]		= true;

		stateName[2]				= "Done";
		stateTimeoutValue[2]		= 0.01;
		stateTransitionOnTimeout[2]	= "FireA";
	};
}

if(!isObject(ZombieSmokeDeathImage))
{
	datablock ShapeBaseImageData(ZombieSmokeDeathImage)
	{
		shapeFile = "base/data/shapes/empty.dts";
		emap = false;

		mountPoint = $BackSlot;
		offset = "0.00 0.50 -0.25";

		stateName[0]				= "Ready";
		stateTimeoutValue[0]		= 0.01;
		stateTransitionOnTimeout[0]	= "FireA";

		stateName[1]				= "FireA";
		stateEmitter[1]				= ZombieSmokerDeathEmitter;
		stateEmitterTime[1]			= 0.9;
		stateTimeoutValue[1]		= 0.9;
		stateTransitionOnTimeout[1]	= "Done";
		stateWaitForTimeout[1]		= true;

		stateName[2]				= "Done";
		stateTimeoutValue[2]		= 0.01;
		stateTransitionOnTimeout[2]	= "FireA";
	};
}

if(!isObject(ZombieSmokerConstrictImage))
{
	datablock ShapeBaseImageData(ZombieSmokerConstrictImage)
	{
		shapeFile = $ZAPT::FilePath::Shapes @ "constricted.1.dts";
		emap = true;
		mountPoint = $BackSlot;
		offset = "0 0 0";
		eyeOffset = "0 0 0";
		rotation = eulerToMatrix("0 0 0");
		firstPerson = false;
		
		className = "WeaponImage";
		item = "";
		
		armReady = false;
		doColorShift = true;
		colorShiftColor = "0.35 0.05 0.075 1.00";
	};
}

// ============================================================
// Section 7 : Zombies
// ============================================================
// All other zombies inhereit default properties from this zombie instance.
if(!isObject(ZombieStandardArmor))
{
	datablock PlayerData(ZombieStandardArmor : PlayerStandardArmor)
	{
		// Standard Properties
		canJet			= false;
		canRide			= false;
		jetEnergyDrain	= 0;
		maxDamage		= 100;
		maxEnergy		= 100;
		maxTools		= 0;
		minJetEnergy	= 0;
		paintable		= false;
		uiName			= "Zombie - Standard";
		rideAble		= true;
		showEnergyBar	= true;
		
		// Speed Properties
		runEnergyDrain = 0;
		runForce = 52 * 90;
		maxBackwardSpeed = 4 + 2.25;
		maxForwardSpeed = 7 + 2.75;
		maxSideSpeed = 6 + 2.00;
		minRunEnergy = 10;
		
		maxBackwardCrouchSpeed = 2 + 1.0;
		maxForwardCrouchSpeed = 3 + 1.0;
		maxSideCrouchSpeed = 2 + 1.0;
		
		jumpForce = 12 * 90;
		jumpEnergyDrain = 0;
		jumpDelay = 3;
		minJumpEnergy = 25;
		
		// Zombie Properties
		isZombieArmor	= true;
		isZombieTank	= false;
		zombieAIOnly	= false;
		zombieAdminOnly	= false;
		zombieUIName	= "a Normal Zombie";
		zombieConstrict	= false;
		zombieDamage	= 5;
		zombieDamType	= $DamageType::Zombies;
		zombieHaetFire	= true;
		zombieHelp		= "Eat humans by clicking them";
		zombieHUDIcon	= "zombie";
		zombieImmunity	= "";
		zombieImportant = false;
		zombieNoSwap	= false;
		zombieScale		= "1 1 1";
		zombieSpawnOnce	= false;
		zombieVelNull	= 1;
		
		// Zombie Hax
		fireRetardant = false;
		useSpecialOn["attack"] = false;
		
		// Zombie Nodes
		zombieCrawl = false;
		
		zombieHideNodes = 0;
		zombieHideNode[1] = "";
		
		zombieShowNodes = 0;
		zombieSHowNode[1] = "";

		
		// Skincolor Properties
		skinColorRedMin = 0;
		skinColorRedMax = 0;
		
		skinColorGreenMin = 0.150;
		skinColorGreenMax = 0.450;
		
		skinColorBlueMin = 0.150;
		skinColorBlueMax = 0.450;
		
		skinColorSym = "gb";
	};
}

if(!isObject(ZombieBitchArmor))
{
	datablock PlayerData(ZombieBitchArmor : ZombieStandardArmor)
	{
		// Standard Properties
		maxDamage		= 275;
		uiName			= "Zombie - Witch";
		
		// Speed Properties
		runForce = 54 * 90;
		maxBackwardSpeed = 4 + 4.0;
		maxForwardSpeed = 7 + 5.0;
		maxSideSpeed = 6 + 3.75;
		
		maxBackwardCrouchSpeed = 2 + 2.0;
		maxForwardCrouchSpeed = 3 + 2.0;
		maxSideCrouchSpeed = 2 + 2.0;
		
		// Zombie Properties
		zombieAIOnly	= true;
		zombieUIName	= "the Wandering Witch";
		zombieDamage	= 200;
		zombieDamType	= $DamageType::Witch;
		zombieHaetFire	= false;
		zombieHelp		= "All you want to do is sit and be left alone.";
		zombieHUDIcon	= "witch";
		zombieSpawnOnce	= true;
		zombieVelNull	= 0.1;
		
		// Zombie Nodes
		zombieCrawl = false;
		
		zombieHideNodes = 4;
		zombieHideNode[1] = "RHook";
		zombieHideNode[2] = "RHand";
		zombieHideNode[3] = "LHook";
		zombieHideNode[4] = "LHand";
		
		// Skincolor Properties
		skinColorRedMin = 0.125;
		skinColorRedMax = 0.125;
		
		skinColorGreenMin = 0.243;
		skinColorGreenMax = 0.243;
		
		skinColorBlueMin = 0.137;
		skinColorBlueMax = 0.137;
		
		skinColorSym = "";
	};
}

if(!isObject(ZombieConsumerArmor))
{
	datablock PlayerData(ZombieConsumerArmor : ZombieStandardArmor)
	{
		// Standard Properties
		maxDamage		= 125;
		uiName			= "Zombie - Consumer";
		
		// Speed Properties
		runForce = 48 * 90;
		maxBackwardSpeed = 4 - 0;
		maxForwardSpeed = 7 - 0;
		maxSideSpeed = 6 - 0;
		minRunEnergy = 10;
		
		maxBackwardCrouchSpeed = 2 - 0;
		maxForwardCrouchSpeed = 3 - 0;
		maxSideCrouchSpeed = 2 - 0;
		
		jumpForce = 10 * 90;
		
		// Zombie Properties
		zombieUIName	= "a Consumer Zombie";
		zombieDamage	= 6;
		zombieHaetFire	= false;
		zombieHelp		= "Bite people, then use Jet to throw up on them";
		zombieHUDIcon	= "consumer";
		
		// Zombie Hax
		useSpecialOn["attack"] = true;
		
		// Skincolor Properties
		skinColorRedMin = 0.350;
		skinColorRedMax = 0.500;
		
		skinColorGreenMin = 0.050;
		skinColorGreenMax = 0.175;
		
		skinColorBlueMin = 0.050;
		skinColorBlueMax = 0.175;
		
		skinColorSym = "gb";
	};
}

if(!isObject(ZombieFallenArmor))
{
	datablock PlayerData(ZombieFallenArmor : ZombieStandardArmor)
	{
		// Standard Properties
		uiName			= "Zombie - Fallen Survivor";
		
		// Zombie Properties
		zombieAIOnly	= true;
		zombieUIName	= "a Fallen Survivor";
	};
}

if(!isObject(ZombieLeaperArmor))
{
	datablock PlayerData(ZombieLeaperArmor : ZombieStandardArmor)
	{
		// Standard Properties
		airControl		= 0.25;
		maxDamage		= 75;
		uiName			= "Zombie - Leaper";
		
		// Speed Properties
		runForce = 52 * 90;
		maxBackwardSpeed = 4 + 2.00;
		maxForwardSpeed = 7 + 2.75;
		maxSideSpeed = 6 + 2.25;
		maxBackwardCrouchSpeed = 2 + 0.5;
		maxForwardCrouchSpeed = 3 + 0.75;
		maxSideCrouchSpeed = 2 + 0.5;
		
		jumpForce = 12 * 90;
		jumpEnergyDrain = 0;
		jumpDelay = 3;
		minJumpEnergy = 25;
		
		// Zombie Properties
		zombieUIName	= "a Leaper Zombie";
		zombieHelp		= "Shift and Jet to jump REALLY far";
		zombieDamage	= 7.5;
		zombieHUDIcon	= "leaper";
		
		// Zombie Hax
		useSpecialOn["jump"] = true;
		
		// Skincolor Properties
		skinColorRedMin = 0.500;
		skinColorRedMax = 0.500;
		
		skinColorGreenMin = 0.500;
		skinColorGreenMax = 0.500;
		
		skinColorBlueMin = 0.500;
		skinColorBlueMax = 0.500;
		
		skinColorSym = "rgb";
	};
}

if(!isObject(ZombieJockeyArmor))
{
	datablock PlayerData(ZombieJockeyArmor : ZombieStandardArmor)
	{
		// Standard Properties
		maxDamage		= 65;
		uiName			= "Zombie - Jockey";
		
		// Speed Properties
		runForce = 50 * 90;
		maxBackwardSpeed = 4 + 1.5;
		maxForwardSpeed = 7 + 2.00;
		maxSideSpeed = 6 + 1.75;
		
		maxBackwardCrouchSpeed = 2 + 0.5;
		maxForwardCrouchSpeed = 3 + 0.75;
		maxSideCrouchSpeed = 2 + 0.5;
		
		// Zombie Properties
		zombieUIName	= "a Jockey Zombie";
		zombieConstrict	= true;
		zombieDamage	= 5;
		zombieHaetFire	= false;
		zombieHelp		= "Jump on people's heads";
		zombieHUDIcon	= "jockey";
		zombieScale		= "0.8 0.8 0.8";
		
		// Skincolor Properties
		skinColorRedMin = 0.700;
		skinColorRedMax = 0.800;
		
		skinColorGreenMin = 0.500;
		skinColorGreenMax = 0.600;
		
		skinColorBlueMin = 0.500;
		skinColorBlueMax = 0.600;
		
		skinColorSym = "gb";
	};
}

if(!isObject(ZombieSmasherArmor))
{
	datablock PlayerData(ZombieSmasherArmor : ZombieStandardArmor)
	{
		// Standard Properties
		maxDamage		= 250; 
		maxEnergy		= 200;
		uiName			= "Zombie - Smasher";
		
		// Speed Properties
		maxBackwardSpeed = 4 + 1.5;
		maxForwardSpeed = 7 + 2.00;
		
		maxBackwardCrouchSpeed = 2 + 0.5;
		maxForwardCrouchSpeed = 3 + 0.75;
		maxSideCrouchSpeed = 2 + 0.5;
		
		// Zombie Properties
		zombieUIName	= "a Smasher Zombie";
		zombieDamage	= 8.5;
		zombieDamType	= $DamageType::Zombies;
		zombieHaetFire	= false;
		zombieHelp		= "Use your Jet to charge at humans";
		zombieHUDIcon	= "smasher";
		zombieVelNull	= 0.4;
		
		// Zombie Hax
		useSpecialOn["attack"] = true;
		
		// Zombie Nodes
		zombieHideNodes = 6;
		zombieHideNode[1] = "lHook";
		zombieHideNode[2] = "lHand";
		zombieHideNode[3] = "lArm";
		zombieHideNode[4] = "lArmSlim";
		zombieHideNode[5] = "rHook";
		zombieHideNode[6] = "rHand";
		
		// Skincolor Properties
		skinColorRedMin = 0.600;
		skinColorRedMax = 0.600;
		
		skinColorGreenMin = 0.600;
		skinColorGreenMax = 0.600;
		
		skinColorBlueMin = 0.350;
		skinColorBlueMax = 0.350;
		
		skinColorSym = "";
	};
}

if(!isObject(ZombieSmasherChargingArmor))
{
	datablock PlayerData(ZombieSmasherChargingArmor : ZombieSmasherArmor)
	{
		// Standard Properties
		uiName			= "";
		
		// Speed Properties
		runEnergyDrain = 1.5;
		runForce = 20 * 90;
		maxBackwardSpeed = 0 + 0;
		maxForwardSpeed = 30 + 0;
		maxSideSpeed = 0 + 0;
		minRunEnergy = 3;
		
		maxBackwardCrouchSpeed = 2 - 1;
		maxForwardCrouchSpeed = 3 - 1;
		maxSideCrouchSpeed = 2 - 1;
		
		jumpForce = 6 * 90;
		jumpEnergyDrain = 0;
		jumpDelay = 3;
		minJumpEnergy = 25;
		
		// Zombie Properties
		zombieUIName	= "charging at high speed!";
		zombieHelp		= "YAAAARRGGHHHHHHHH";
		zombieNoSwap	= true;
		zombieVelNull	= 0;
		
		// Skincolor Properties
		skinColorRedMin = 1.0;
		skinColorRedMax = 1.0;
		
		skinColorGreenMin = 0;
		skinColorGreenMax = 0;
		
		skinColorBlueMin = 0;
		skinColorBlueMax = 0;
		
		skinColorSym = "";
	};
}

if(!isObject(ZombieSmokerArmor))
{
	datablock PlayerData(ZombieSmokerArmor : ZombieStandardArmor)
	{
		// Standard Properties
		uiName			= "Zombie - Smoker";
		
		// Zombie Properties
		zombieUIName	= "a Smoker Zombie";
		zombieConstrict	= true;
		zombieHaetFire	= false;
		zombieHelp		= "Use your jet key while looking at survivors to strangle them";
		zombieHUDIcon	= "smoker";
		zombieStalker	= true;
		
		// Skincolor Properties
		skinColorRedMin = 0.100;
		skinColorRedMax = 0.150;
		
		skinColorGreenMin = 0.400;
		skinColorGreenMax = 0.425;
		
		skinColorBlueMin = 0.500;
		skinColorBlueMax = 0.575;
		
		skinColorSym = "";
	};
}

if(!isObject(ZombieSWATArmor))
{
	datablock PlayerData(ZombieSWATArmor : ZombieStandardArmor)
	{
		// Standard Properties
		uiName			= "Zombie - Generic Soldier";
		
		// Zombie Properties
		zombieHelp		= "Only your head is vulnerable";
		zombieUIName	= "a Soldier Zombie";
	};
}

if(!isObject(ZombieSwimmerArmor))
{
	datablock PlayerData(ZombieSwimmerArmor : ZombieStandardArmor)
	{
		// Standard Properties
		uiName			= "Zombie - Swimmer";
		
		// Speed Properties
		runForce = 48 * 90;
		maxBackwardSpeed = 4 - 0.75;
		maxForwardSpeed = 7 - 1.25;
		maxSideSpeed = 6  - 1;
		
		maxBackwardCrouchSpeed = 2 - 0.5;
		maxForwardCrouchSpeed = 3 - 0.75;
		maxSideCrouchSpeed = 2 - 0.5;
		
		maxUnderwaterBackwardSpeed = 7.8 + 4;
		maxUnderwaterForwardSpeed = 8.4 + 6;
		maxUnderwaterSideSpeed = 7.8 + 4;
		
		// Zombie Properties
		ZombieAIOnly	= true;
		zombieUIName	= "a Swimmer Zombie";
		zombieDamage	= 6.5;
		
		// Zombie Hax
		fireRetardant = true;
		
		skinColorGreenMin = 0;
		skinColorGreenMax = 0;
		
		skinColorBlueMin = 0.650;
		skinColorBlueMax = 0.850;
		
		skinColorSym = "gb";
	};
}

if(1 || !isObject(ZombieTankArmor))
{
	datablock PlayerData(ZombieTankArmor : ZombieStandardArmor)
	{
		// Standard Properties
		maxDamage		= 1000;
		maxEnergy		= 200;
		uiName			= "Zombie - Tank";
		rideAble		= false;
		
		// Speed Properties
		maxBackwardSpeed = 4 + 1.5;
		maxForwardSpeed = 7 + 2.00;
		
		maxBackwardCrouchSpeed = 2 + 0.5;
		maxForwardCrouchSpeed = 3 + 0.75;
		maxSideCrouchSpeed = 2 + 0.5;
		
		// Zombie Properties
		isZombieTank	= true;
		zombieUIName	= "the Tank";
		zombieDamage	= 15;
		zombieDamType	= $DamageType::TankPunch;
		zombieHaetFire	= false;
		zombieHelp		= "Kill everything that moves";
		zombieHUDIcon	= "tank";
		zombieImmunity	= $DamageType::Radius SPC $DamageType::Vehicle SPC $DamageType::VehicleExplosion;
		zombieImportant	= true;
		zombieNoSwap	= true;
		zombieScale		= "1.35 1.35 1.35";
		zombieVelNull	= 0;
		
		// Zombie Nodes
		zombieHideNodes = 4;
		zombieHideNode[1] = "lHook";
		zombieHideNode[2] = "lHand";
		zombieHideNode[3] = "rHook";
		zombieHideNode[4] = "rHand";
		
		// Skincolor Properties
		skinColorRedMin = 0.200;
		skinColorRedMax = 0.200;
		
		skinColorGreenMin = 0.200;
		skinColorGreenMax = 0.200;
		
		skinColorBlueMin = 0;
		skinColorBlueMax = 0;
		
		skinColorSym = "rg";
	};
}
