// ============================================================
// ===================== Welcome to ZAPT ======================
// ============================================================
// Project				:	ZAPT
// Author				:	Iban
// Description			:	Project Initialization
// ============================================================
// Table of Contents
// 
// 1. Variables and Definitions
// 2. RTB
// 3. Scripts
// ============================================================

// This isn't some dick move making people choose one or the other.
// Rotondo's mod breaks mine, not the other way around.
// I'm not sure why, and I don't care.
// Remove this at your own peril.
if($AddOn__Gamemode_zombie $= "1" && isFile("Add-Ons/Gamemode_zombie/server.cs"))
{
	// Local connection?
	if(isFunction("MessageBoxOK"))
	{
		schedule(2500, 0, "MessageBoxOK", "GameMode_ZAPT Refusing to Execute!", "GameMode_ZAPT has failed to execute because:\n\nYou have the incompatible Add-On, \"Gamemode_zombie,\" enabled.\n\n\This MUST be disabled before GameMode_ZAPT will work.");
	}
	
	echo("\c2 +- GameMode_ZAPT will not execute because you have the incompatible Add-On \"Gamemode_zombie\" enabled. \"Gamemode_zombie\" must be disabled before GameMode_ZAPT will work.");
	
	return;
}

// ============================================================
// Section 1 : Variables and Definitions
// ============================================================
// Spams the living SHIT out of your console with useful information.
$ZAPT::DirectorDebug = false;
// Will cause a console error in clients if it does not match their version.
$ZAPT::Version = 2.1;

// TCP Properties
// Wait for v3.
$ZAPT::TCP::Enaled = false;
$ZAPT::TCP::address = "blog.ichverbot.com:80";
$ZAPT::TCP::directory = "/zapt";
$ZAPT::TCP::DebugTCP = false;

// ============================================================
// Section 2 : RTB
// ============================================================
if(!$ZAPT_Temp::RTBPrefsRegistered)
{
	$ZAPT_Temp::RTBPrefsRegistered = true;
	
	if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
	{
		if(!$RTB::RTBR_ServerControl_Hook)
		{
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		}
		
		RTB_registerPref("Admin Only", "ZAPT", "$ZAPT::AdminOnly", "bool", "GameMode_ZAPT", false, false, false, "ZAPT_UpdateAdmin");
		
		RTB_registerPref("Army Name", "ZAPT", "$ZAPT::ArmyName", "string 64", "GameMode_ZAPT", "Generic Army", false, false, "ZAPT_UpdateArmy");
		RTB_registerPref("Enable Condition Name Colors", "ZAPT", "$ZAPT::ConditionColors", "bool", "GameMode_ZAPT", true, false, false, "ZAPT_UpdateColorcode");
		RTB_registerPref("Saferoom Trigger Height", "ZAPT", "$ZAPT::SaferoomHeight", "int 1 64", "GameMode_ZAPT", 15, false, true, "ZAPT_UpdateHeight");
		
		RTB_registerPref("Mobs are Allowed", "ZAPT", "$ZAPT::Mobs", "bool", "GameMode_ZAPT", true, false, true, "ZAPT_UpdateMobs");
		RTB_registerPref("Mob Size Cap", "ZAPT", "$ZAPT::MobSize", "int 0 50", "GameMode_ZAPT", 30, false, true, "ZAPT_UpdateMobSize");
		
		RTB_registerPref("Zombie Max Distance", "ZAPT", "$ZAPT::MaxDist", "int 16 248", "GameMode_ZAPT", 48, false, true, "ZAPT_UpdateDistance");
		RTB_registerPref("Zombie Think Time", "ZAPT", "$ZAPT::ThinkEvery", "int 50 1000", "GameMode_ZAPT", 500, false, true, "ZAPT_UpdateThink");
	}
	else
	{
		// Name of the army that is sent. Appears in bottom print.
		$ZAPT::ArmyName = "Generic Army";
		// Will change a player's name based on their condition.
		$ZAPT::ConditionColors = true;
		// The maximum distance (1 = 2 brick studs) that a zombie can function and spawn from a human.
		$ZAPT::MaxDist = 48;
		// Overrides minigame prefs.
		$ZAPT::Mobs = true;
		// A hard cap on the number of freelance zombies that can exist in the server at any point.
		$ZAPT::MobSize = 10;
		// How tall the saferoom trigger is in flat-bricks.
		$ZAPT::SaferoomHeight = 15;
		// Zombies process information every X ms.
		// Higher number, the more responsive and intelligent.
		// Higher number, the more CPU eaten.
		$ZAPT::ThinkEvery = 500;
	}
}

// ============================================================
// Section 3 : Scripts
// ============================================================
// File Paths
$ZAPT::FilePath = "Add-Ons/GameMode_ZAPT/";
$ZAPT::FilePath::Bricks		= $ZAPT::FilePath @ "bricks/";
$ZAPT::FilePath::Icons		= $ZAPT::FilePath @ "icons/";
$ZAPT::FilePath::Scripts	= $ZAPT::FilePath @ "scripts/";
$ZAPT::FilePath::Shapes		= $ZAPT::FilePath @ "shapes/";
$ZAPT::FilePath::Sounds		= $ZAPT::FilePath @ "sounds/";

// Scripts
exec($ZAPT::FilePath::Scripts @ "scriptobjects.cs");
exec($ZAPT::FilePath::Scripts @ "objects.cs");
exec($ZAPT::FilePath::Scripts @ "zombies.cs");
exec($ZAPT::FilePath::Scripts @ "functions.cs");
exec($ZAPT::FilePath::Scripts @ "package.cs");

// Mutations
ZombieMutations.addMutation($ZAPT::FilePath::Scripts @ "mutations/Mutation_Infection.cs");
ZombieMutations.addMutation($ZAPT::FilePath::Scripts @ "mutations/Mutation_Versus.cs");
ZombieMutations.addMutation($ZAPT::FilePath::Scripts @ "mutations/Mutation_TankArena.cs");

// This should never, ever execute - UNLESS TDM is actually enabled.
if($AddOn__Gamemode_TeamDeathmatch $= "1" && isFile("Add-Ons/GameMode_TeamDeathmatch/server.cs"))
{
	// ZAPT is executed before TDM, so this needs to be hung.
	schedule(32, 0, "exec", $ZAPT::FilePath::Scripts @ "teamdeathmatch.cs");
}